import 'dart:convert';

import 'package:agora_rtc/FUManager/FUManager.dart';
import 'package:agora_rtc/shared_storage/AgoraSharedConstant.dart';
import 'package:agora_rtc/shared_storage/AgoraSharedUtils.dart';


class FUConfig {
  static List<FUBeautyParam> currentSkinList = [];
  static List<FUBeautyParam> currentFacialList = [];
  static List<FUBeautyParam> currentBeautifyBodyList = [];

  static List<FUBeautyParam> currentFiltersList = [];
  static List<FUBeautyParam> currentStickerList = [];
  static List<FUBeautyParam> currentMakeupsList = [];

  static Future initialize() async {
    // String skinJson = await AgoraSharedUtils.getString(AgoraSharedConstant.fcSkinShare);
    // if (skinJson.length == 0) {
      currentSkinList = getSkinDefine();
    // } else {
    //   currentSkinList = [];
    //   List skinMapList = json.decode(skinJson);
    //   skinMapList.forEach((element) {
    //     currentSkinList.add(FUBeautyParam.fromJson(element));
    //   });
    // }
    currentSkinList.forEach((element) {
      FUManager.setSkinBeautyParam(element);
    });

    // String facialJson =
    //     await AgoraSharedUtils.getString(AgoraSharedConstant.fcFacialShare);
    // if (facialJson.length == 0) {
      currentFacialList = getFacialDefine();
    // } else {
    //   currentFacialList = [];
    //   List facialMapList = json.decode(facialJson);
    //   facialMapList.forEach((element) {
    //     currentFacialList.add(FUBeautyParam.fromJson(element));
    //   });
    // }
    currentFacialList.forEach((element) {
      FUManager.setFacialBeautyParam(element);
    });

    // // String beautifyBodyJson =
    // //     await SharedUtils.getString(SharedConstant.fcBeautifyBodyShare);
    // // if (beautifyBodyJson.length == 0) {
      currentBeautifyBodyList = getBeautifyBodyDefine();
    // // } else {
    // //   currentBeautifyBodyList = [];
    // //   List beautifyBodyMapList = json.decode(beautifyBodyJson);
    // //   beautifyBodyMapList.forEach((element) {
    // //     currentBeautifyBodyList.add(FUBeautyParam.fromJson(element));
    // //   });
    // // }
    // currentBeautifyBodyList.forEach((element) {
    //   FUManager.setBeautifyBodyBeautyParam(element);
    // });

    // String filterJson =
    //     await AgoraSharedUtils.getString(AgoraSharedConstant.fcFiltersShare);
    // if (filterJson.length == 0) {
      currentFiltersList = getFiltersDefine();
    // } else {
    //   currentFiltersList = [];
    //   List filterMapList = json.decode(filterJson);
    //   filterMapList.forEach((element) {
    //     currentFiltersList.add(FUBeautyParam.fromJson(element));
    //   });
    // }
    // bool isSy = false;
    // currentFiltersList.forEach((element) {
      
    //   if (element.isSeleted != null && element.isSeleted! && isSy == false) {
    //     isSy = true;
    //     FUManager.setFliterBeautyParam(element);
    //   }
    // });

    //   String stickerJson =
    //     await SharedUtils.getString(SharedConstant.fcStickerShare);
    // if (stickerJson.length == 0) {
      // currentStickerList = getFiltersDefine();
    // } else {
    //   currentFiltersList = [];
    //   List filterMapList = json.decode(filterJson);
    //   filterMapList.forEach((element) {
    //     currentFiltersList.add(FUBeautyParam.fromJson(element));
    //   });
    // }

    // String makeupJson =
    //     await SharedUtils.getString(SharedConstant.fcMakeupShare);
    // if (makeupJson.length == 0) {
      currentStickerList = getStickerDefine();
      currentMakeupsList = getMakeupDefine();
    // } else {
    //   currentMakeupsList = [];
    //   List makeupMapList = json.decode(makeupJson);
    //   makeupMapList.forEach((element) {
    //     currentMakeupsList.add(FUBeautyParam.fromJson(element));
    //   });
    // }
  }

  static List<FUBeautyParam> getSkinDefine() {
    List<FUBeautyParam> define = [
      FUBeautyParam(
          mParam: 'blur_level',
          mValue: 0.38,
          type: 0,
          mTitle: 'Buffing',
          image: 'zhibo_meiyan_meifu_btn_mopi'),
      FUBeautyParam(
          mParam: 'color_level',
          mValue: 0.36,
          type: 0,
          mTitle: 'Whitening',
          image: 'zhibo_meiyan_meifu_btn_meibai'),
      FUBeautyParam(
          mParam: 'red_level',
          mValue: 0.37,
          type: 0,
          mTitle: 'Ruddy',
          image: 'zhibo_meiyan_meifu_btn_hongrun'),
      FUBeautyParam(
          mParam: 'eye_bright',
          mValue: 0.50,
          type: 0,
          mTitle: 'Brightly eyes',
          image: 'zhibo_meiyan_meifu_btn_liangyan'),
      FUBeautyParam(
          mParam: 'tooth_whiten',
          mValue: 0.50,
          type: 0,
          mTitle: 'White teeth',
          image: 'zhibo_meiyan_meifu_btn_meiya'),
      FUBeautyParam(
          mParam: 'remove_pouch_strength',
          mValue: 0.59,
          type: 0,
          mTitle: 'Remove Dark Circle',
          image: 'zhibo_meiyan_meifu_btn_heiyanquan'),
      FUBeautyParam(
          mParam: 'remove_nasolabial_folds_strength',
          mValue: 0.50,
          type: 0,
          mTitle: 'Remove Wrinkles',
          image: 'zhibo_meiyan_meifu_btn_falingwen')
    ];
    currentSkinList = define;
    // SharedUtils.remove(SharedConstant.fcSkinShare);
    return define;
  }

  static List<FUBeautyParam> getFacialDefine() {
    List<FUBeautyParam> define = [
      FUBeautyParam(
          mParam: 'cheek_thinning',
          mValue: 0.24,
          type: 0,
          mTitle: 'Thin face',
          image: 'zhibo_meiyan_meixing_btn_shoulian'),
      FUBeautyParam(
          mParam: 'cheek_v',
          mValue: 0.50,
          type: 0,
          mTitle: 'V face',
          image: 'zhibo_meiyan_meixing_btn_vlian'),
      FUBeautyParam(
          mParam: 'cheek_narrow',
          mValue: 0.22,
          type: 0,
          mTitle: 'Narrow face',
          image: 'zhibo_meiyan_meixing_btn_zhailian'),
      FUBeautyParam(
          mParam: 'cheek_small',
          mValue: 0.22,
          type: 0,
          mTitle: 'Small face',
          image: 'zhibo_meiyan_meixing_btn_xiaolian'),
      FUBeautyParam(
          mParam: 'eye_enlarging',
          mValue: 0.30,
          type: 0,
          mTitle: 'Eyes',
          image: 'zhibo_meiyan_meixing_btn_dayan'),
      FUBeautyParam(
          mParam: 'intensity_chin',
          mValue: 0.30,
          type: 0,
          mTitle: 'Chin',
          image: 'zhibo_meiyan_meixing_btn_xiaba'),
      FUBeautyParam(
          mParam: 'intensity_forehead',
          mValue: 0.30,
          type: 0,
          mTitle: 'Forehead',
          image: 'zhibo_meiyan_meixing_btn_etou'),
      FUBeautyParam(
          mParam: 'intensity_nose',
          mValue: 0.50,
          type: 0,
          mTitle: 'Thin nose',
          image: 'zhibo_meiyan_meixing_btn_shoubi'),
      FUBeautyParam(
          mParam: 'intensity_mouth',
          mValue: 0.40,
          type: 0,
          mTitle: 'Mouth',
          image: 'zhibo_meiyan_meixing_btn_zuixing'),
      FUBeautyParam(
          mParam: 'intensity_canthus',
          mValue: 0.00,
          type: 0,
          mTitle: 'Corner of eyes',
          image: 'zhibo_meiyan_meixing_btn_kaiyanjiao'),
      FUBeautyParam(
          mParam: 'intensity_eye_space',
          mValue: 0.50,
          type: 0,
          mTitle: 'Eye distance',
          image: 'zhibo_meiyan_meixing_btn_yanju'),
      FUBeautyParam(
          mParam: 'intensity_eye_rotate',
          mValue: 0.50,
          type: 0,
          mTitle: 'Eye angle',
          image: 'zhibo_meiyan_meixing_btn_yanjingjiaodu'),
      FUBeautyParam(
          mParam: 'intensity_long_nose',
          mValue: 0.50,
          type: 0,
          mTitle: 'Lang nose',
          image: 'zhibo_meiyan_meixing_btn_changbi'),
      FUBeautyParam(
          mParam: 'intensity_philtrum',
          mValue: 0.50,
          type: 0,
          mTitle: 'Shrink philtrum',
          image: 'zhibo_meiyan_meixing_btn_suorenzhong'),
      FUBeautyParam(
          mParam: 'intensity_smile',
          mValue: 0.00,
          type: 0,
          mTitle: 'Smiling lips',
          image: 'zhibo_meiyan_meixing_btn_weixiaochun')
    ];
    currentFacialList = define;
    // SharedUtils.remove(SharedConstant.fcFacialShare);
    return define;
  }

  static List<FUBeautyParam> getBeautifyBodyDefine() {
    List<FUBeautyParam> define = [
      FUBeautyParam(
          mParam: 'BodySlimStrength',
          mValue: 0.00,
          type: 4,
          mTitle: 'Slimming',
          image: 'zhibo_meiyan_meiti_btn_shoushen'),
      FUBeautyParam(
          mParam: 'LegSlimStrength',
          mValue: 0.00,
          type: 4,
          mTitle: 'Long legs',
          image: 'zhibo_meiyan_meiti_btn_changtui'),
      FUBeautyParam(
          mParam: 'WaistSlimStrength',
          mValue: 0.00,
          type: 4,
          mTitle: 'Thin waist',
          image: 'zhibo_meiyan_meiti_btn_xiyao'),
      FUBeautyParam(
          mParam: 'ShoulderSlimStrength',
          mValue: 0.00,
          type: 4,
          mTitle: 'Shoulder',
          image: 'zhibo_meiyan_meiti_btn_meijian'),
      FUBeautyParam(
          mParam: 'HipSlimStrength',
          mValue: 0.00,
          type: 4,
          mTitle: 'Hip',
          image: 'zhibo_meiyan_meiti_btn_fengtun'),
      FUBeautyParam(
          mParam: 'HeadSlim',
          mValue: 0.00,
          type: 4,
          mTitle: 'Lessen head',
          image: 'zhibo_meiyan_meiti_btn_xiaotou'),
      FUBeautyParam(
          mParam: 'LegSlim',
          mValue: 0.00,
          type: 4,
          mTitle: 'Leg slimming',
          image: 'zhibo_meiyan_meiti_btn_shoutui')
    ];
    // currentBeautifyBodyList = define;
    // SharedUtils.remove(SharedConstant.fcBeautifyBodyShare);
    return define;
  }

  static List<FUBeautyParam> getFiltersDefine() {
    List<FUBeautyParam> define = [
      FUBeautyParam(
          mParam: 'origin',
          mValue: 0.60,
          type: 1,
          mTitle: 'Default',
          image: 'zhibo_meiyan_meiti_btn_shoushen'),
      FUBeautyParam(
          mParam: 'ziran1',
          mValue: 0.60,
          type: 1,
          mTitle: 'Nature',
          isSeleted: true,
          image: 'zhibo_meiyan_lvjing_ziran'),
      FUBeautyParam(
          mParam: 'zhiganhui1',
          mValue: 0.60,
          type: 1,
          mTitle: 'Simple sense',
          image: 'zhibo_meiyan_lvjing_zhiganhui'),
      FUBeautyParam(
          mParam: 'bailiang1',
          mValue: 0.60,
          type: 1,
          mTitle: 'White',
          image: 'zhibo_meiyan_lvjing_bailiang'),
      FUBeautyParam(
          mParam: 'fennen1',
          mValue: 0.60,
          type: 1,
          mTitle: 'Pink',
          image: 'zhibo_meiyan_lvjing_fennen'),
      FUBeautyParam(
          mParam: 'lengsediao1',
          mValue: 0.60,
          type: 1,
          mTitle: 'Cool',
          image: 'zhibo_meiyan_lvjing_lengsediao'),
    ];
    currentFiltersList = define;
    // SharedUtils.remove(SharedConstant.fcFiltersShare);
    return define;
  }

  static List<FUBeautyParam> getMakeupDefine() {
    List<FUBeautyParam> define = [
      FUBeautyParam(
          mParam: 'makeup_noitem',
          mValue: 0.70,
          type: 3,
          mTitle: 'Default',
          image: ''),
      FUBeautyParam(
          mParam: 'naicha',
          mValue: 0.70,
          type: 3,
          mTitle: 'type 1',
          image: 'zhibo_meiyan_meizhuang_naicha'),
      FUBeautyParam(
          mParam: 'dousha',
          mValue: 0.70,
          type: 3,
          mTitle: 'type 2',
          image: 'zhibo_meiyan_lvjing_dousha'),
      FUBeautyParam(
          mParam: 'chaoA',
          mValue: 0.70,
          type: 3,
          mTitle: 'type 3',
          image: 'zhibo_meiyan_lvjing_chaoa'),
    ];
    // currentMakeupsList = define;
    // SharedUtils.remove(SharedConstant.fcMakeupShare);
    return define;
  }
  static List<FUBeautyParam> getStickerDefine() {
    List<FUBeautyParam> define = [
      FUBeautyParam(
          mParam: 'makeup_noitem',
          mValue: 0.70,
          type: 2,
          mTitle: 'Default',
          image: ''),
      // FUBeautyParam(
      //     mParam: 'fashi',
      //     mValue: 0.70,
      //     type: 2,
      //     mTitle: 'fashi',
      //     image: 'zhibo_meiyan_meiti_btn_changtui'),
      FUBeautyParam(
          mParam: 'sdlu',
          mValue: 0.70,
          type: 2,
          mTitle: 'sticker1',
          image: 'zhibo_meiyan_tiezhi_xiaolu'),
      FUBeautyParam(
          mParam: 'xueqiu_lm_fu',
          mValue: 0.70,
          type: 2,
          mTitle: 'sticker2',
          image: 'zhibo_meiyan_tiezhi_xueren'),
    ];
    // currentMakeupsList = define;
    // SharedUtils.remove(SharedConstant.fcMakeupShare);
    return define;
  }
}

class FUBeautyParam {
  String? mTitle;
  String? mParam;
  double? mValue;
  String? image;
  int? type;
  bool? isSeleted;

  FUBeautyParam(
      {this.mTitle,
      this.mParam,
      this.mValue,
      this.image,
      this.isSeleted = false,
      this.type = 0});

  FUBeautyParam.fromJson(Map<String, dynamic> json) {
    mTitle = json['mTitle'];
    mParam = json['mParam'];
    mValue = json['mValue'];
    image = json['image'];
    type = json['type'];
    isSeleted = json['isSeleted'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['mTitle'] = this.mTitle;
    data['mParam'] = this.mParam;
    data['mValue'] = this.mValue;
    data['image'] = this.image;
    data['type'] = this.type;
    data['isSeleted'] = this.isSeleted;
    return data;
  }
}
